VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "G3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2002 by SAS Institute Inc.
Option Explicit

Implements SEGAddIn                             'Required interface to implement
Implements SEGTask                              'Required interface to implement
Implements SEGTaskInfo
Implements SEGErrorSink

Private Task As MyDialog                        'Our form to display to the user
Private Application As SEGApplication           'Needed in other function calls


Private Sub SEGAddIn_Connect(ByVal ppiApplication As SASAIOBJLib.ISEGApplication, ByVal lCookie As Long, plSuccess As Long)
    Set Application = ppiApplication            'Store the interface for use later in this module
    Set Task = New MyDialog                     'Allocate the memory for the form on demand
    plSuccess = APP_CONNECTION_SUCCESS          'Need to return 1 for the connection to be successful
End Sub

Private Sub SEGAddIn_Disconnect()
    Unload Task                                 'Clean up the allocated form
End Sub

Private Sub SEGAddIn_GetDescription(pbstrVal As String)
   'The description that describes this AddIn
    pbstrVal = "A Sample Add-In created using Visual Basic.  It Does not require input data."
End Sub

Private Sub SEGAddIn_GetName(pbstrVal As String)
    pbstrVal = "Simple Graph Example"          'The display name that references to this AddIn
End Sub

Private Sub SEGErrorSink_ExecutionError(ByVal lErrorCode As Long, ByVal bstrDescription As String, ByVal bstrProgID As String, ByVal bstrMethod As String, ByVal bstrParameter As String)
    Dim ErrorText As String
    
    ErrorText = ErrorText & _
        "An Error " & CStr(lErrorCode) & " occured with the " & bstrProgID & _
        "Task while calling" & vbCrLf & "the method """ & bstrMethod & _
        """ and attempting to use the parameter """ & bstrParameter & """."
        
    If bstrDescription <> "" Then
        ErrorText = ErrorText & vbCrLf & vbCrLf & bstrDescription
    End If
    
    MsgBox ErrorText, vbCritical, "AddIn Error"
End Sub


Private Sub SEGTask_GetOptionsFlag(plOptions As Long)
    'plOptions = APP_TASK_CATEGORY_USER_DEFINED
    plOptions = APP_TASK_CATEGORY_GRAPH
End Sub

Private Sub SEGTask_GetOutputDataCount(plCount As Long)
    plCount = 1
End Sub

Private Sub SEGTask_GetOutputDataInfo(ByVal lIndex As Long, pbstrSource As String, pbstrLabel As String, plFile As Long)
    If (lIndex = 0) Then
        pbstrSource = "WORK.HAT"
        pbstrLabel = "Generated Hat Data"
        plFile = 0
    End If
End Sub

Private Sub SEGTask_GetProperty(ByVal bstrKey As String, pbstrVal As String)
    If bstrKey = "SERVER" Then
        pbstrVal = Task.Server
    End If
    
    If bstrKey = "CODE" Then
        pbstrVal = Task.Code
    End If
    
    If bstrKey = "AUTHOR" Then
        pbstrVal = Task.Author
    End If
End Sub

Private Sub SEGTask_GetPropertyList(pbstrKeyArray() As String)
    ReDim pbstrKeyArray(2) As String
    pbstrKeyArray(0) = "AUTHOR"
    pbstrKeyArray(1) = "CODE"
    pbstrKeyArray(2) = "SERVER"
End Sub

Private Sub SEGTask_GetRequiresData(plVal As Long)
    plVal = APP_DATAOPTION_NONE
End Sub

Private Sub SEGTask_GetRunLog(pbstrVal As String)
    pbstrVal = "The SAS code was unavailable!"
End Sub

Private Sub SEGTask_GetSubmitCode(pbstrCode As String)
    pbstrCode = Task.Code
End Sub

Private Sub SEGTask_Initialize(plSuccess As Long)
    plSuccess = APP_INITIALIZE_SUCCESS
End Sub

Private Sub SEGTask_SetProperty(ByVal bstrKey As String, ByVal bstrVal As String)

    If bstrKey = "AUTHOR" Then
        If bstrVal <> "" Then
            Task.Author = bstrVal
        End If
    End If
    
   If bstrKey = "SERVER" Then
        If bstrVal <> "" Then
            Task.Server = bstrVal
        End If
    End If
    
    If bstrKey = "CODE" Then
        If bstrVal <> "" Then
            Task.Code = bstrVal
        End If
    End If
    
End Sub

Private Sub SEGTask_Show(ByVal lParentWindowHandle As Long, plStatus As Long)
  
    Task.mOkUpdate = False
    Task.Show vbModal                           'Display the dialog
    plStatus = APP_SHOW_CANCELED                'Initialize the status parameter
    
    If Task.mOkUpdate = True Then
        Application.AssignServer Task.Server
        plStatus = APP_SHOW_RUNNOW              'Set the status to success
    End If
    
End Sub

Private Sub SEGTask_Terminate()
    Unload Task
End Sub

Private Sub SEGTaskInfo_GetTaskCategory(pbstrVal As String)
    pbstrVal = "Custom"
End Sub

Private Sub SEGTaskInfo_GetTaskDescription(pbstrVal As String)
    pbstrVal = "Calls PROC G3D to do simple Graphing"
End Sub

Private Sub SEGTaskInfo_GetTaskMajorVersion(plVal As Long)
    plVal = 1
End Sub

Private Sub SEGTaskInfo_GetTaskMinorVersion(plVal As Long)
    plVal = 1
End Sub

Private Sub SEGTaskInfo_GetTaskName(pbstrVal As String)
    pbstrVal = "Graph Example"
End Sub

Private Sub SEGTaskInfo_GetTaskProcsUsed(pbstrVal As String)
    pbstrVal = "G3D"        'Use ; as a delimeter
End Sub

Private Sub SEGTaskInfo_GetTaskType(plType As Long)
    plType = APP_TASKTYPE_WIZARD
End Sub

Private Sub SEGTaskInfo_GetTaskValidation(pbstrVal As String)
    pbstrVal = "Sample"
End Sub

